unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, registry;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    PaintBox1: TPaintBox;
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure DrawEyes;
    procedure DrawPupil(x,y:integer);
    procedure UpdateEyes(scrx,scry:integer);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1StartDrag(Sender: TObject;
      var DragObject: TDragObject);
  private
  eyewidth, eyeheight,bwidth:integer;
    startupcomplete:boolean;
    oldx,oldy,formx,formy,formh,formw,tbh,bw:integer;
    updrect:trect;
    backbuffer:tbitmap;
    bgColor,fgColor,outlinecolor:tcolor;

    { Private declarations }
  public

    { Public declarations }
end; {type}

var
  Form1: TForm1;


resourcestring
  AppRegKey ='SOFTWARE\JograData\xEyes';

implementation

{$R *.DFM}

procedure SaveToRegistry;
var reg:Tregistry;
begin
 reg:=Tregistry.Create;
 reg.RootKey:=HKEY_LOCAL_MACHINE;
 If reg.OpenKey(appRegKey,true) then
  with reg do
  begin
   writeFloat('Version',1.1);
   writeinteger('x',Form1.Top);
   writeinteger('y',Form1.Left);
   CloseKey;
   free;
  end;
end;

procedure LoadFromRegistry;
var reg:Tregistry;
begin
 reg:=Tregistry.Create;
 reg.RootKey:=HKEY_LOCAL_MACHINE;
 If reg.OpenKey(appRegKey,false) then
  with reg do
  begin
   Form1.Top:=readinteger('x');
   Form1.left:=readinteger('y');
   CloseKey;
   free;
  end;
end;

procedure TForm1.DrawEyes;
begin
  with backbuffer.Canvas do
  begin
    pen.Color:=outlineColor;
    brush.Color:=outlineColor;
    FillRect(rect(0,0,2*eyewidth,eyeheight));
    pen.Color:=bgColor;
    brush.Color:=bgColor;
    Ellipse(bwidth,bwidth,eyewidth-bwidth,eyeheight-bwidth);
    Ellipse(eyewidth+bwidth,bwidth,(2*eyewidth)-bwidth,eyeheight-bwidth);
  end;
end;

procedure TForm1.DrawPupil(x,y:integer);
begin
  with backbuffer.canvas do
  begin
    brush.Color:=fgColor;
    pen.color:=fgColor;
    backbuffer.Canvas.Ellipse(x,y,x+12,y+16);
  end;
end;

function calcAngle(h,b:integer):double;
begin
  if b=0 then
    result:=pi/2
  else
    result:=arctan(h/b);
end;

procedure TForm1.UpdateEyes(scrx,scry:integer);
var SCXR,SCYR,SCXL,SCYL:integer;
    LTPXL,LTPYL,LTPXR,LTPYR:integer;
    XCL,XCR,YCN:integer;
    xRadL,xRadR,yRadL,yRadR:integer;
    angleL,angleR:double;
begin
  XCL:=round(0.5*eyewidth);
  XCR:=round(1.5*eyewidth);
  YCN:=round(0.5*eyeheight);

  SCXR:=form1.left+XCR+4+bw; // Eye Centers
  SCYR:=form1.top+YCN+tbh;
  SCXL:=form1.left+XCL+4+bw;
  SCYL:=form1.top+YCN+tbh;

  LTPXL:=scxl-scrx; // Distances to Mouse
  LTPYL:=scyl-scry;
  LTPXR:=scxr-scrx;
  LTPYR:=scyr-scry;

  // Calc Angles
  angleL:=calcAngle(LTPYL,LTPXL);
  angleR:=calcAngle(LTPYR,LTPXR);

  // Handle Pupils when mouse is OVER the Eyes
  xRadL:=ABS(LTPXL);
  yRadL:=ABS(LTPYL);
  xRadR:=ABS(LTPXR);
  yRadR:=ABS(LTPYR);
  if xRadL > (eyewidth div 2)-2*bwidth then xRadL:=(eyewidth div 2)-2*bwidth;
  if yRadL > (eyeheight div 2)-2*bwidth then yRadL:=(eyeheight div 2)-2*bwidth;
  if xRadR > (eyewidth div 2)-2*bwidth then xRadR:=(eyewidth div 2)-2*bwidth;
  if yRadR > (eyeheight div 2)-2*bwidth then yRadR:=(eyeheight div 2)-2*bwidth;

  // Draw the eyes
  DrawEyes;
  // Something to clean up the nasty ARCTAN thingy...
  // (Right Pupil)
  if SCRX < SCXR then
  begin
    xRadR:=-xRadR;
    yRadR:=-yRadR;
  end;
  if (xRadR=0) and (SCRY < SCYR) then
    yRadR:=-yRadR;

  DrawPupil(XCR+(ROUND(cos(angleR)*xRadR)-bwidth),YCN+(ROUND(sin(angleR)*yRadR))-bwidth);

  // Left Pupil
  if SCRX < SCXL then
  begin
    xRadL:=-xRadL;
    yRadL:=-yRadL;
  end;
  if (xRadL=0) and (SCRY < SCYL) then
    yRadL:=-yRadL;

  DrawPupil(XCL+(ROUND(cos(angleL)*xRadL))-bwidth,YCN+(ROUND(sin(angleL)*yRadL))-bwidth);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var here:TPoint;
    scrX,scrY:integer;
begin
  getcursorpos(here); //Get Mouse-screen coordinate to TPoint "here"
  scrx:=here.x;
  scry:=here.y;
  // Only update when mouse has moved...
  if not ((scry=oldy) and (scrx=oldx)) then
  begin
    UpDateEyes(scrx,scry);
    paintBox1.Canvas.CopyRect(updrect,backbuffer.canvas,updrect);
  end;
  oldx:=scrx;
  oldy:=scry;
end;

function ConvertRGBTriplet(colorstr:string):tcolor;
var r,g,b:byte;
begin
  r:=(strtoint('$'+colorstr) shr 16) and 255;
  g:=(strtoint('$'+colorstr) shr 8)and 255;
  b:=strtoint('$'+colorstr) and 255;
  result:=RGB(r,g,b);
end;

procedure TForm1.FormCreate(Sender: TObject);
var region,otheregion:hrgn;
    pcnt:integer;
    pst:string;
begin
  formx:=maxint;
  formy:=maxint;
    Loadfromregistry;
    if not(formx=maxint) then form1.Left:=formx;
    if not(formy=maxint) then form1.top:=formy;

  bgcolor:=clWhite;
  fgcolor:=clBlack;
  outlineColor:=clblack;
  startupComplete:=false;
  eyewidth:=75;
  eyeheight:=100;
  bwidth:=4;
  // Parameter Parsing goes here:
  if paramcount > 0 then
  begin
   for pcnt:=1 to paramcount do
   begin
    pst:=lowercase(paramstr(pcnt));
    if pst='-fg' then fgcolor:=ConvertRGBTriplet(paramstr(pcnt+1));
    if pst='-bg' then bgcolor:=ConvertRGBTriplet(paramstr(pcnt+1));
    if pst='-outline' then outlinecolor:=ConvertRGBTriplet(paramstr(pcnt+1));
    if pst='-x' then form1.left:=strtoint(paramstr(pcnt+1));
    if pst='-y' then form1.top:=strtoint(paramstr(pcnt+1));
    if pst='-height' then eyeheight:=strtoint(paramstr(pcnt+1));
    if pst='-width' then eyewidth:=strtoint(paramstr(pcnt+1));
   end;
  end;

  // Do "Running with Scissors"
  bw:=(width-clientwidth) shr 1;
  tbh:=(height-clientheight)-bw;
  clientWidth:=2*eyewidth;
  clientHeight:=eyeheight;
  region := CreateEllipticRgn(bw, tbh, eyewidth+bw, eyeheight+tbh);
  otheregion := CreateEllipticRgn(eyewidth+bw, tbh, 2*eyewidth+bw, eyeheight+tbh);
  CombineRgn(region,region,otheregion,RGN_OR);
  SetWindowRgn(Handle, region, TRUE);

  // Make BackBuffer Image
  backbuffer:=TBitmap.Create;
  backbuffer.Width:=form1.ClientWidth;
  backbuffer.Height:=form1.ClientHeight;

  // Intialize
  updrect:=rect(0,0,form1.clientWidth,form1.clientheight);
  oldx:=0;
  oldy:=0;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveToRegistry;
  backbuffer.Free;  // Cleanup to isle 7...
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ShowWindow(Application.Handle, Sw_Hide); // Hide TaskBar Entry
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  paintBox1.Canvas.CopyRect(updrect,backbuffer.canvas,updrect); // Repaint
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
  SC_DragMove = $F012; // Magic number
begin
  ReleaseCapture;
  Form1.perform(WM_SysCommand, SC_DragMove,0);
end;

procedure TForm1.PaintBox1StartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
  Form1.DoStartDrag(Dragobject); // Move it!
end;

end.
